ScriptWriterParser Class Reference documentation

ScriptWriterParser Class Referencefinal

the main class to read a Script Writer 1.3 file More...

`#include <ScriptWriterParser.hxx>`

Inheritance diagram for ScriptWriterParser:

## Public Member Functions
| ScriptWriterParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~ScriptWriterParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | readDocument ()
| try to read the document header
bool | readPrintInfo ()
| try to read the print information
bool | readFrame (ScriptWriterParserInternal::Frame &frame)
| try to read a frame entry
bool | readCharStyle (ScriptWriterParserInternal::Page &page, int column)
| try to read the character style
bool | readPage (ScriptWriterParserInternal::Page &page)
| try to read page
bool | readTextZone ()
| try to read the main text zone
bool | readHFStyle (std::map< int, MWAWFont > &posToFontMap)
| try to read the hf style
bool | readPicture (MWAWEntry &entry)
| try to read a picture entry
bool | readFont (MWAWFont &font)
| try to read a font
bool | send (ScriptWriterParserInternal::HFData const &hf)
| try to send a header/footer
bool | sendText (ScriptWriterParserInternal::Frame const &frame)
| try to send a frame text
bool | sendMainZone ()
| try to send the main text zone
bool | sendText (ScriptWriterParserInternal::Page const &page)
| try to send a page text
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< ScriptWriterParserInternal::State > | m_state
| the state

## Friends
class | ScriptWriterParserInternal::SubDocument

## Detailed Description

the main class to read a Script Writer 1.3 file

## Constructor & Destructor Documentation

## ◆ ScriptWriterParser()

ScriptWriterParser::ScriptWriterParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~ScriptWriterParser()

ScriptWriterParser::~ScriptWriterParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool ScriptWriterParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse(), and ScriptWriterParserInternal::SubDocument.

## ◆ createDocument()

void ScriptWriterParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse(), and ScriptWriterParserInternal::SubDocument.

## ◆ createZones()

bool ScriptWriterParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and ScriptWriterParserInternal::SubDocument.

## ◆ parse()

void ScriptWriterParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by ScriptWriterParserInternal::SubDocument.

## ◆ readCharStyle()

bool ScriptWriterParser::readCharStyle | ( | ScriptWriterParserInternal::Page & | page,
|  | int | column )
| protected

try to read the character style

Referenced by readPage(), and ScriptWriterParserInternal::SubDocument.

## ◆ readDocument()

bool ScriptWriterParser::readDocument | ( |  | ) |
| protected

try to read the document header

Referenced by createZones(), and ScriptWriterParserInternal::SubDocument.

## ◆ readFont()

bool ScriptWriterParser::readFont | ( | MWAWFont & | font | ) |
| protected

try to read a font

Referenced by readCharStyle(), readDocument(), and ScriptWriterParserInternal::SubDocument.

## ◆ readFrame()

bool ScriptWriterParser::readFrame | ( | ScriptWriterParserInternal::Frame & | frame | ) |
| protected

try to read a frame entry

Referenced by createZones(), and ScriptWriterParserInternal::SubDocument.

## ◆ readHFStyle()

bool ScriptWriterParser::readHFStyle | ( | std::map< int, MWAWFont > & | posToFontMap | ) |
| protected

try to read the hf style

Referenced by ScriptWriterParserInternal::SubDocument, and sendText().

## ◆ readPage()

bool ScriptWriterParser::readPage | ( | ScriptWriterParserInternal::Page & | page | ) |
| protected

try to read page

Referenced by createZones(), and ScriptWriterParserInternal::SubDocument.

## ◆ readPicture()

bool ScriptWriterParser::readPicture | ( | MWAWEntry & | entry | ) |
| protected

try to read a picture entry

Referenced by createZones(), and ScriptWriterParserInternal::SubDocument.

## ◆ readPrintInfo()

bool ScriptWriterParser::readPrintInfo | ( |  | ) |
| protected

try to read the print information

Referenced by createZones(), and ScriptWriterParserInternal::SubDocument.

## ◆ readTextZone()

bool ScriptWriterParser::readTextZone | ( |  | ) |
| protected

try to read the main text zone

Referenced by createZones(), and ScriptWriterParserInternal::SubDocument.

## ◆ send()

bool ScriptWriterParser::send | ( | ScriptWriterParserInternal::HFData const & | hf | ) |
| protected

try to send a header/footer

Referenced by ScriptWriterParserInternal::SubDocument.

## ◆ sendMainZone()

bool ScriptWriterParser::sendMainZone | ( |  | ) |
| protected

try to send the main text zone

Referenced by parse(), and ScriptWriterParserInternal::SubDocument.

## ◆ sendText() [1/2]

bool ScriptWriterParser::sendText | ( | ScriptWriterParserInternal::Frame const & | frame | ) |
| protected

try to send a frame text

Referenced by ScriptWriterParserInternal::SubDocument, send(), and sendMainZone().

## ◆ sendText() [2/2]

bool ScriptWriterParser::sendText | ( | ScriptWriterParserInternal::Page const & | page | ) |
| protected

try to send a page text

## Friends And Related Symbol Documentation

## ◆ ScriptWriterParserInternal::SubDocument

friend class ScriptWriterParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<ScriptWriterParserInternal::State> ScriptWriterParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), readDocument(), readTextZone(), ScriptWriterParser(), send(), sendMainZone(), sendText(), and sendText().

The documentation for this class was generated from the following files:

- ScriptWriterParser.hxx
- ScriptWriterParser.cxx